<!--Un petit test des commentaires en Markdown
...concluant !-->
# 00.Remarques générales

### Contenu
Globalement un contenu très (très) riche ! Surtout si on inclut toutes les références. 

L'ouverture sur différentes disciplines est intéressante.
La mise en perspective historique aussi.

### Pédagogie
Les explications sont claires.
Globalement le tempo est lent.
En x1.5, ça passe mieux !

### Choix des outils
Pas forcément applicable au monde de l'entreprise. Confidentialité Git ?

# 0.Posons le décor
Pas si simple de définir la reproductibilité dans différents domaines de recherche.
[Texte recherche reproductible](https://gitlab.inria.fr/learninglab/mooc-rr/mooc-rr-ressources/blob/master//module0/ressources/ReproducibilityCrisisHistory_fr.md)

La transparence permet d'aller dans le sens de la reproductibilité mais en pratique, ce n'est pas toujours possible pour diverses raisons.
On peut la décomposer :
- data transparency : ”Providing full access to data itself“
- analytic transparency : ”Information about data analysis“
- production transparency : ”Process of data collection“

# 1.Module 1 : Notes, indexation, pérennité

DocFetcher → indexation locale  
Exiftool → éditer les méta-données  
Pérennité pour les traitements de texte (entre autres)

# 2.Module 2 : Document computationnel
Etudes ratées célèbres :
- Reinhart et Rogoff: Growth in a Time of Debt
- 2010 Bennett et al.: Le saumon mort IRM → parodie pour montrer la facilité de mal interpréter des données d'IRM
- 2016 Elkund, Nicholas and Knutsson : 3600 articles pourraient être invalidés à cause d'un bug dans un logiciel
- 2003,2005 Geoffrey Chang : sur les bactéries → inversion de colonne dans l'analyse de données 5 articles rétractés !

Nécessiter de tout **expliciter**
→ transparence pour soi (rigueur) et pour les autres

Avec les logiciels sophistiqués, on va très vite mais on fait plus facilement des erreurs.  
Tableurs - code de gênes ou de protéines interprétés comme des dates ou des chiffres  
Logiciels propriétaires - non-lisible

Pile logiciel : s'assurer de la fiabilité de chaque brique.

Manque de rigueur, perte de données  
Back-up, historique, revue de code

Description de haut niveau (article, voir présentation ppt!) nécessaire mais important de tout tracer et rendre disponible !!

Tout publier montre les faiblesses mais valide la fiabilité, expose les erreurs et tant mieux pour être corrigé   
Données sensibles, OK mais doit être inspectable à la demande.

Les 100 articles les plus cités en 2014 (58M articles) : que de la méthodo et des logiciels !  
43% jamais cités, 74% moins de 10 fois. [Nature top100 papers](https://www.nature.com/news/the-top-100-papers-1.16224)

### Jupyter

Jupyter est en JSON → pas fichier texte !
[Méthodo Recherche (Martin Quinson)](https://people.irisa.fr/Martin.Quinson/Research/Students/Methodo/)
Not. pour la biblio : [Efficient Reading of Papers in Science and technology](https://people.irisa.fr/Martin.Quinson/Research/Students/efficientReading.pdf)

- [ ] Ne pas oublier ces cases à cocher sur Markdown, qui sont susceptibles de faire des jolies checklists !
- [X] Ca, c'est fait !
 
### Rédaction

La [présentation sur l'art de l'écriture scientifique d'Arnaud Legout](https://people.irisa.fr/Martin.Quinson/Research/ScientificWriting.pdf )(depuis la page de Martin Quinson) est des plus intéressantes avec de multiples exemples.  
Ce que je retiens :
- Objectif : être clair, facile et agréable à lire + structure/histoire convainquante
- Style
    - phrases : 
        - ne pas éloigner les sujets et les verbes : SUJET+VERBE+RESTE
        - éviter les subtantivation de verbes, ex : ~~les sociétés pratiquent la délocalisation~~ vs. les sociétés délocalisent 
        - éviter sauf exception de style la voie passive, oser dire "je" ou plutôt "nous"
        - éviter ou décomposer les groupes nominaux composés
        - éviter les circonlocutions, être direct
    - le flux (construire un paragraphe) :
        - le schéma d'une phrase : **FAMILIER → NOUVEAU**, ex : concept déjà introduit → développement / info générale → surprenante / simple → technique/complexe
        - placer les derniers mots d'une phrase pour une **emphase**
        - la 1ère phrase d'un paragraphe donne le thème (max 2 thème/§)
        - nommer les choses avec cohérence, *éviter les synonymes* !
        - utiliser les parallélismes, ex : pour trois raisons. Premièrement... / D'un côté, (...). De l'autre
    - phrases complexes : **CLARTÉ → COMPLEXITÉ (grâce)**
        - premiers mots → intro thème, simple
        - sauf transition avec la phrase précédente (flux), préférer mettre les morceaux complexes à la fin.
        - (éviter les parenthèses et les appositions)
        - 3 technique pour une phrase complexe :
            - virer les *pronoms relatifs* et faire des phrases distinctes 
            - utiliser des "resumptive modifsers" (répétition), ex: "nous avons testé **ce distributeur, un distributeur** *décevant, décevant* en performance, *décevant* en coût"
            - utiliser des 'summative modifiers" (résumé), ex: "La HTU est doublée sans augmentation de la capacité, cette mauvaise performance globale est due..."
            - utiliser des coordinations : **SYMETRIE** ou **COURT/SIMPLE → LONG/COMPLEXE**
            - Emphase "l'un et l'autre" → "l'un comme l'autre", "non seulement (...), mais", "ni, ni"
            - utiliser la suspension ...avec modération
    - Rythme : phrases courtes → urgence, passion / phrases longues → confusion, introspection / **EQUILIBRE, MESURE**
- HISTOIRE : Le problème (du général au spécifique), Notre contribution, Enseignements et impact

# 4.Module 4 : Terrain

## 1.Enfer des données
Disparates ou composites
 - les colonnes n'ont pas la même longueur
 - données chronologiques, images

Quantité de données, taille des données
 - format texte : méta-données, universel
 - format binaire : compacité, dépend de l'OS (boutisme)
    - FTIS (orig. astrophysicien, ∃ pyFITS) et HDF5 (hiérarchique, pas de structure imposée, ∃ h5py)

Formats de fichiers
Archivage et partage

## 2.Enfer du logiciel
Taille
Vieillissement

Work-flow → simplifie la lecture du logiciel, représentation en graph

Work-flow → moins d'erreurs possibles
Notebook → priorité à la narration, difficulté de parallélisation  
    Poser des Checkpoint pour éviter les parties coûteuses

Eco-systèmes complexes → installations, mises-à-jour, dépendance  
    Contrôler son environnement : machine virtuelle, conteneur docker (plus léger)

Epreuve du temps :  
    Exemple changement Python 2 → Python 3  
    Cortical thickness Measurements PC vs MAC !!
    

## 3.Calcul numérique
Temps d'exécution vs. reproductibilité  
**Arrondi implicite en flottant !**  
Pas évident de maîtriser l'ordre des opérations (compilateur optimisé, calculs parallèles)

Maîtrise l'ordre des opérations ? → pas simple

Calcul = plateforme (matériel+infrastructure) + logiciel + données 

**Nombres aléatories**  
PSEUDO-aléatoire
Reproductibilité : ISO graine + algorithme


## 4.Conclusions

# X.Citations à garder

*Il me semble que l'apparat savant contemporain est comparable à un grand magasin qui contient une grande quantité de produits, stockés de façon totalement désordonnée, mélangée ; où les nombres ou lettres d'indexation manquent ; où les inventaires et livres de comptes pouvant aider à ordonner le contenu ont disparu. Plus grande est la quantité d'objets amassés, plus petite est leur utilité. Ainsi, ne devrions nous pas seulement essayer de rassembler de nouveaux objets de toutes provenances, mais nous devrions aussi essayer d'ordonner ceux que nous avons déjà.*  
Leibniz

*Le but de toute cette pratique de prise de notes est de préserver la valeur [le temps et les moyens humains et matériels investis dans la recherche]. Elle devrait être soigneusement conçus pour s'adapter aux conditions de chaque laboratoire et devraient être adéquate mais pas trop élaborés. __Si l'on exige trop de la nature humaine, le système ne fonctionnera pas.__*  
E. Bright Wilson

*An article about computational science in a scientific publication is not the scholarship itself, it is merely advertising of the scholarship. The actual scholarship is the complete software development environment and the complete set of instructions which generated the figures.*  
Jonathan Buckheit and David Donoho

*How you begin a sentence
determines its clarity;  
how you end it determines
its rhythm and grace*  
J. M. Williams (Style, Toward Clarity and Grace)

*To make science more scientific, we need : more transparency, more accountability, lower expectations.*
Simine Vazire
